##
##Ajgu, a graphe database in Python for Python users
##Copyright (C) 2010 Amirouche Boubekki <amirouche.boubekki@gmail.com>
##
##This program is free software: you can redistribute it and/or modify
##it under the terms of the GNU Affero General Public License as published by
##the Free Software Foundation, either version 3 of the License, or
##(at your option) any later version.
##
##This program is distributed in the hope that it will be useful,
##but WITHOUT ANY WARRANTY; without even the implied warranty of
##MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##GNU Affero General Public License for more details.
##
##You should have received a copy of the GNU Affero General Public License
##along with this program.  If not, see <http://www.gnu.org/licenses/>.
##

from persistent_dictionnary import PersistentDictionnary
import node

class Arrow(PersistentDictionnary):
    def __init__(self, backend, start=None, end=None, id=None):
        PersistentDictionnary.__init__(self, backend, id)

        if id == None:
            self._set_start(start)
            self._set_end(end)
        
    def _get(self, type):
        node_id = self._get_private_property(type)
        return node.Node(self._backend, id=long(node_id))
            
    def get_start(self):
        return self._get("start")
    
    def get_end(self):
        return self._get("end")

    def _set(self, type, node):
        self._set_private_property(type, str(node._id))

        try:
            raw_arrows = node._get_private_property("arrows")
            raw_arrows += "," + str(self._id)
        except:
            raw_arrows = str(self._id)
        node._set_private_property("arrows:%s" % type, raw_arrows)
        
    def _set_start(self, start):
        self._set("start", start)

    def _set_end(self, end):
        self._set("end", end)
