##
##Ajgu, a graphe database in Python for Python users
##Copyright (C) 2010 Amirouche Boubekki <amirouche.boubekki@gmail.com>
##
##This program is free software: you can redistribute it and/or modify
##it under the terms of the GNU Affero General Public License as published by
##the Free Software Foundation, either version 3 of the License, or
##(at your option) any later version.
##
##This program is distributed in the hope that it will be useful,
##but WITHOUT ANY WARRANTY; without even the implied warranty of
##MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##GNU Affero General Public License for more details.
##
##You should have received a copy of the GNU Affero General Public License
##along with this program.  If not, see <http://www.gnu.org/licenses/>.
##

from backends import AnyDbBackend
from backends.utils import validate_property
from node import Node

class GrapheDatabase:
    def __init__(self, backend=AnyDbBackend):
        self._backend = backend

    def create_node(self):
        return Node(self._backend)

    def close():
        self._backend.close()

    def get_node(self, id_):
        self._backend.get_property(Node.__name__,
                                   id_,
                                   "private",
                                   "")
        return Node(self._backend, id=id_)

    def get_node_counter(self):
        return self._backend.get_class_count(Node.__class__.__name__)        

