from persistent_dictionnary import PersistentDictionnary
##
##Ajgu, a graphe database in Python for Python users
##Copyright (C) 2010 Amirouche Boubekki <amirouche.boubekki@gmail.com>
##
##This program is free software: you can redistribute it and/or modify
##it under the terms of the GNU Affero General Public License as published by
##the Free Software Foundation, either version 3 of the License, or
##(at your option) any later version.
##
##This program is distributed in the hope that it will be useful,
##but WITHOUT ANY WARRANTY; without even the implied warranty of
##MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##GNU Affero General Public License for more details.
##
##You should have received a copy of the GNU Affero General Public License
##along with this program.  If not, see <http://www.gnu.org/licenses/>.
##

from arrow import Arrow

class Node(PersistentDictionnary):
    def __init_(self, backend, id=None):
        PersistentDictionnary.__init__(self, backend, id=id)

    def add_arrow(self, node):
        arrow = Arrow(self._backend, start=self, end=node)
        return arrow

    def _get_arrows(self, type):
        arrows = list()
        try:
            raw_ids = self._get_private_property(type)
        except:
            return arrows

        list_ids = raw_ids.split(",")

        for id in list_ids:            
            arrow = Arrow(self._backend, id=long(id))
            arrows.append(arrow)
        return arrows

    def get_incoming_arrows(self):
        return self._get_arrows("arrows:end")

    def get_outgoing_arrows(self):
        return self._get_arrows("arrows:start")

    def delete(self):
        for arrow in self.get_incoming_arrows():
            arrow.delete()
        for arrow in self.get_outgoing_arrows():
            arrow.delete()
        PersistentDictionnary.delete(self)

    def set_index(self, property):
        validate_property(property)
        
